/*Public Domain by Pabs <pabs3@zip.to>*/
#include <stdio.h>
#include <fcntl.h>
#include <io.h>

#define STR "Microsoft"
#define REPSTR "Micro$oft"
#define LEN sizeof(STR)-1

int main( void ){
	int i;
	char found;
	int t[LEN];
	char s[] = STR;

	/*Check (at compile time) if the strings are different sizes
	  since this could be disastrous if we filter executables*/
	if(LEN!=sizeof(REPSTR)-1)
		fputs("Warning: the two strings are not of equal"
		" length\nThis means that alignment problems may"
		" occur (especially in executable files)",stderr);

	/*Make sure input & output are not being munged*/
	if( setmode( fileno( stdin ), O_BINARY ) == -1 ){
		perror( "Cannot set stdin to binary mode" ); return -1;
	}
	if( setmode( fileno( stdout ), O_BINARY ) == -1 ){
		perror( "Cannot set stdout to binary mode" ); return -1;
	}

INIT:
	/*Initialise the bytes*/
	for(i=0;i<LEN-1;i++)t[i]=getc(stdin);
	t[LEN-1]=EOF;
	/*Get another byte*/
	while(EOF!=(t[LEN-1]=getc(stdin))){
		found=1;
		/*Find the string*/
		for(i=0;i<LEN;i++)if(t[i]!=s[i]){found=0;break;}
		/*If the string is found*/
		if(found){
			fputs(REPSTR,stdout);
			goto INIT;
		}
		/*Otherwise*/
		else{
			/*Put the oldest char out to stud*/
			putc(t[0],stdout);
			/*Shuffle the queue*/
			for(i=1;i<LEN-1;i++)t[i-1]=t[i];
			t[LEN-1]=EOF;
		}
	}
	/*Empty the queue*/
	for(i=0;i<LEN;i++)if(t[i]!=EOF){putc(t[i],stdout);t[i]=EOF;}
	/*Success*/
	return 0;
}